"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultApiConfigurationParser = void 0;
var xml2js_1 = require("xml2js");
var apiConfiguration_1 = require("./apiConfiguration");
var DefaultApiConfigurationParser = /** @class */ (function () {
    function DefaultApiConfigurationParser() {
    }
    DefaultApiConfigurationParser.prototype.parse = function (xmlConfig) {
        return new Promise(function (resolve, reject) {
            // tslint:disable-next-line:no-any
            (0, xml2js_1.parseString)(xmlConfig, { charkey: 'value', attrkey: 'attributes' }, function (err, result) {
                if (err) {
                    reject(err);
                }
                else {
                    var rawConfig = result;
                    if (rawConfig) {
                        try {
                            resolve(new apiConfiguration_1.DefaultApiConfiguration(result));
                        }
                        catch (err) {
                            reject(err);
                        }
                    }
                    else {
                        reject(new Error("invalid configuration: ".concat(xmlConfig)));
                    }
                }
            });
        });
    };
    return DefaultApiConfigurationParser;
}());
exports.DefaultApiConfigurationParser = DefaultApiConfigurationParser;
//# sourceMappingURL=apiConfigurationParser.js.map